<template>
  <div class="row q-col-gutter-md">
    <div class="col-12 col-md-6">
      <q-select
        outlined
        v-model="city"
        :options="cityOptions"
        label="Tỉnh thành *"
        @input="onSelectCity"
      />
    </div>
    <div class="col-12 col-md-6">
      <q-select
        outlined
        v-model="district"
        :options="districtOptions"
        label="Quận/Huyện *"
        @input="onSelectDistrict"
      />
    </div>
    <div class="col-12 col-md-6">
      <q-select
        outlined
        v-model="ward"
        :options="wardOptions"
        label="Xã/Phường *"
        @input="emitData"
      />
    </div>
    <div class="col-12 col-md-6">
      <q-input v-model="address" outlined label="Địa chỉ liên lạc *" @input="emitData" />
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';

export default {
  props: {
    value: { type: Object, default: () => ({}) }
  },
  data() {
    return {
      city: '',
      district: '',
      ward: '',
      address: '',
      cityObj: {},
      districtObj: {},
      wardObj: {}
    };
  },
  computed: {
    ...mapState({
      cities: state => state.resources.cities
    }),
    cityOptions() {
      return this.cities.map(city => city.name).sort();
    },
    districtOptions() {
      return (this.cityObj.districts || []).map(d => d.name).sort();
    },
    wardOptions() {
      return (this.districtObj.wards || []).map(w => w.name);
    }
  },
  watch: {
    value: {
      handler() {
        this.city = this.value.city;
        this.district = this.value.district;
        this.ward = this.value.ward;
        this.address = this.value.address;
      },
      immediate: true
    }
  },
  mounted() {
    this.getCities();
  },
  methods: {
    ...mapActions({
      getCities: 'resources/getCities'
    }),
    emitData() {
      this.$emit('input', {
        city: this.city,
        district: this.district,
        ward: this.ward,
        address: this.address
      });
    },
    onSelectCity(value) {
      this.cityObj = this.cities.find(c => c.name === value);
      this.district = '';
      this.ward = '';
      this.emitData();
    },
    onSelectDistrict(value) {
      this.districtObj = this.cityObj.districts.find(d => d.name === value);
      this.ward = '';
      this.emitData();
    }
  }
};
</script>
